#!/usr/bin/env python3
# -*- coding: utf-8 -*-

class Dictionnaire:
    def __init__(self):
        """Construit le dictionnaire vide"""
        self.contenu = []
    def taille(self):
        return len(self.contenu)
    def contient_cle(self, cle):
        for c, _ in self.contenu:
            if c == cle:
                return True
        # on n'a pas trouvé la clé
        return False
    def valeur(self, cle):
        for c, v in self.contenu:
            if c == cle:
                return v
        # on n'a pas trouvé la clé demandée: on soulève l'exception attendue
        raise KeyError
    def change(self, cle, valeur):
        for i in range(len(self.contenu)):
            c, v = self.contenu[i]
            if c == cle:
                # le dictionnaire contient déjà la clé
                # on met à jour la valeur
                self.contenu[i] = valeur
                return
        # on n'a pas trouvé la clé demandée: on crée une nouvelle entrée
        self.contenu.append((cle,valeur))
    def liste_cles(self):
        return [c for c, _ in self.contenu]
    def supprime(self,cle):
        for i in range(len(self.contenu)):
            c, _ = self.contenu[i]
            if c == cle:
                self.contenu.pop(i)
                return
        # on n'a pas trouvé la clé demandée: on soulève l'exception attendue
        raise KeyError
