#!/usr/bin/env python3
# -*- coding: utf-8 -*-
class File:
    def __init__(self, taille=2**8):
        """Retourne une file vide (avec de la place pour 1024 valeurs par défaut)."""
        self.valeurs = taille*[None]
        self.tete = None # indique la case où on a inséré plus ancien élément, ou bien `None` si la pile est vide
        self.queue = 0 # indique la case où on insèrera le prochain élément
    
    def __str__(self):
        if self.est_vide():
            return "File(vide)"
        if self.tete < self.queue:
            vraies_valeurs = self.valeurs[self.tete:self.queue]
        else:
            vraies_valeurs = self.valeurs[self.tete:] + self.valeurs[:self.queue]
        return f"File(contenu: {vraies_valeurs})"

    def __len__(self):
        if self.est_vide():
            return 0
        elif self.tete < self.queue:
            return self.queue - self.tete
        else:
            return len(self.valeurs) + self.queue - self.tete
            
    def est_vide(self):
        return self.tete is None
    
    def entree(self,x):
        if self.est_vide():
            self.tete = 0
            self.valeurs[0] = x
            self.queue = 1
            return
        if self.tete == self.queue:
            # la file n'sest pas vide et la queue a rattrapé la tête
            # on choisit de planter au lieu de générer un tableau plus gros
            raise IndexError("tente d'insérer une valeur dans une file pleine")
        self.valeurs[self.queue] = x
        self.queue = (self.queue + 1) % len(self.valeurs)

    def sortie(self):
        if self.est_vide():
            raise IndexError("impossible de sortir un élément d'une file vide")
        x = self.valeurs[self.tete]
        self.tete = (self.tete + 1) % len(self.valeurs)
        if self.tete == self.queue:
            # on a retiré le dernier élément
            self.tete = None
        return x