#!/usr/bin/env python3
# -*- coding: utf-8 -*-

def npi(programme):
    pile = []
    for instruction in programme:
        if instruction == "add":
            x = pile.pop()
            y = pile.pop()
            pile.append(y+x)
        elif instruction == "mul":
            x = pile.pop()
            y = pile.pop()
            pile.append(y*x)
        elif instruction == "sub":
            x = pile.pop()
            y = pile.pop()
            pile.append(y-x)
        elif instruction == "div":
            x = pile.pop()
            y = pile.pop()
            pile.append(y/x)
        elif instruction == "aff":
            print(pile[-1])
        elif instruction == "dup":
            pile.append(pile[-1])
        elif instruction == "ech":
            x = pile.pop()
            y = pile.pop()
            pile.append(x)
            pile.append(y)
        elif instruction == "nbr":
            print(len(pile))
        else:
            pile.append(instruction)
    if len(pile):
        return(pile[-1])
    else:
        return None

def test_npi():
    p = [1,1,"add","aff","dup","mul","aff","dup","mul"]
    print("résultat:", npi(p))