#!/usr/bin/env python3
# -*- coding: utf-8 -*-

def sousmot_en_position(u,v,i):
    """Renvoie `True` si `u` contient une copie de `v` à la position `i`,
    `False` sinon. On suppose que `i >= 0` et `i + len(v) <= len(u)
    (le comportement n'est pas défini sinon)."""
    for j in range(len(v)):
        if v[j] != u[i+j]:
            return False
    return True

def position_sousmot(u,v):
    """Renvoie la position de la première copie de `v` dans `u`,
    ou bien `None` s'il n'y en a pas."""
    for i in range(len(u)-len(v)+1):
        if sousmot_en_position(u,v,i):
            return i
    return None