#!/usr/bin/env python3
# -*- coding: utf-8 -*-
def partitionne(t,debut,fin):
    """Partitionne la tranche `[debut:fin]` de `t` au sens du tri rapide.
    Retourne la position du pivot après partition."""
    pivot = t[debut]
    # on stocke d'abord les deux morceaux de la partition dans des tableaux séparés
    t1 = []
    t2 = []
    for x in range(debut+1,fin):
        if x < pivot:
            t1.append(x)
        else:
            t2.append(x)
    # ensuite on recopie le contenu dans l'intervalle
    l1 = len(t1)
    l2 = len(t2)
    for i in range(l1):
        t[debut+i] = t1[i]
    t[debut+l1] = pivot
    for i in range(l2):
        t[debut+l1+1+i] = t2[i]
    return debut+l1
    
def tri_rapide_rec(t,debut,fin):
    """Trie la tranche `[debut:fin]` du tableau `t` en appliquant le tri rapide."""
    if fin <= debut + 1:
        return
    pivot = partitionne(t, debut, fin)
    tri_rapide_rec(t, debut, pivot)
    tri_rapide_rec(t, pivot+1, fin)

def tri_rapide(t):
    """Trie le tableau `t` en place en appliquant le tri rapide."""
    tri_rapide_rec(t,0,len(t))