#!/usr/bin/env python3
# -*- coding: utf-8 -*-

class Arbre:
    """Une classe pour les arbres étiquetés ou muets.""" 
    def __init__(self,enfants=(),valeur=None):
        """On crée un arbre à partir de la liste de ses enfants (de n'importe
        quel type séquentiel, vide par défaut), et d'une éventuelle étiquette
        pour la racine."""
        self.valeur = valeur
        self.enfants = tuple(enfants)
    def __getitem__(self,i):
        return self.enfants[i]
    def __len__(self):
        return len(self.enfants)
    def __repr__(self):
        valeur_s = "" if self.valeur is None else repr(self.valeur) 
        enfants_s = ",".join(repr(t) for t in self.enfants)
        if enfants_s:
            if valeur_s:
                return f'Arbre([{ enfants_s }],{ valeur_s })'
            return f'Arbre([{ enfants_s }])'
        if valeur_s:
            return f'Arbre(valeur={ valeur_s })'
        return "Arbre()"
            
